DECLARE SUB RandomDots (Number!, Kolor!)
DECLARE SUB TypeWrite (Row!, Col!, Text$, Kolor!)
DECLARE SUB Box (Row1!, Col1!, Row2!, Col2!, Kolor!)
DECLARE SUB Box3d (TopX!, TopY!, BottomX!, BottomY!, InsideColor!)
DECLARE SUB Center (Row, Text$)
DECLARE SUB CenterBig (Row, Text$)
DECLARE SUB FadeOutColors ()
DECLARE SUB FadeIn ()
DECLARE SUB FadeInSetup ()
DECLARE SUB FadeOutColor (ColorFading)
DECLARE SUB FadeOut ()
DECLARE SUB Hold ()
DECLARE SUB Rest (Seconds!)
END

CLS

' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
' |                   THE QUICKBASIC SUB COLLECTION: Box                    |
' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
SUB Box (Row1, Col1, Row2, Col2, Kolor)
  COLOR Kolor
  BoxWidth = Col2 - Col1 + 1

  LOCATE Row1, Col1
  PRINT ""; STRING$(BoxWidth - 2, ""); "";

  FOR A = Row1 + 1 TO Row2 - 1
    LOCATE A, Col1
    PRINT ""; SPACE$(BoxWidth - 2); "";
  NEXT A

  LOCATE Row2, Col1
  PRINT ""; STRING$(BoxWidth - 2, ""); "";
END SUB

' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
' |                  THE QUICKBASIC SUB COLLECTION: Box3d                   |
' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
SUB Box3d (TopX, TopY, BottomX, BottomY, InsideColor)
  LINE (TopX, TopY)-(BottomX, BottomY), 8, B
  LINE (TopX - 1, TopY - 1)-(BottomX + 1, BottomY + 1), 8, B
  LINE (TopX - 2, TopY - 2)-(BottomX + 2, BottomY + 2), 7, B
  LINE (TopX - 3, TopY - 3)-(BottomX + 3, BottomY + 3), 7, B
  LINE (TopX - 4, TopY - 4)-(BottomX + 4, BottomY + 4), 15, B
  LINE (TopX - 5, TopY - 5)-(BottomX + 5, BottomY + 5), 15, B
  LINE (TopX - 6, TopY - 6)-(BottomX + 6, BottomY + 6), 7, B
  LINE (TopX - 7, TopY - 7)-(BottomX + 7, BottomY + 7), 7, B
  LINE (TopX - 8, TopY - 8)-(BottomX + 8, BottomY + 8), 8, B
  LINE (TopX - 9, TopY - 9)-(BottomX + 9, BottomY + 9), 8, B
  IF InsideColor > -1 AND InsideColor < 16 THEN LINE (TopX + 1, TopY + 1)-(BottomX - 1, BottomY - 1), InsideColor, BF
END SUB

' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
' |                  THE QUICKBASIC SUB COLLECTION: Center                  |
' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
SUB Center (Row, Text$)
  LOCATE Row, INT(41 - LEN(Text$) / 2)
  PRINT Text$
END SUB

' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
' |                THE QUICKBASIC SUB COLLECTION: CenterBig                 |
' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
SUB CenterBig (Row, Text$)
  LOCATE Row, INT(21 - LEN(Text$) / 2)
  PRINT Text$
END SUB

' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
' |                  THE QUICKBASIC SUB COLLECTION: FadeIn                  |
' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
SUB FadeIn
  DIM Blue(15)
  DIM Green(15)
  DIM Red(15)
  DIM Blue2(15)
  DIM Green2(15)
  DIM Red2(15)
  DIM Done(15)

  Blue2(1) = 40
  Green2(1) = 0
  Red2(1) = 0

  Blue2(2) = 0
  Green2(2) = 40
  Red2(2) = 0

  Blue2(3) = 40
  Green2(3) = 40
  Red2(3) = 0

  Blue2(4) = 0
  Green2(4) = 0
  Red2(4) = 40
  
  Blue2(5) = 40
  Green2(5) = 0
  Red2(5) = 40

  Blue2(6) = 0
  Green2(6) = 20
  Red2(6) = 40

  Blue2(7) = 40
  Green2(7) = 40
  Red2(7) = 40

  Blue2(8) = 20
  Green2(8) = 20
  Red2(8) = 20

  Blue2(9) = 40
  Green2(9) = 20
  Red2(9) = 10

  Blue2(10) = 0
  Green2(10) = 40
  Red2(10) = 0

  Blue2(11) = 40
  Green2(11) = 40
  Red2(11) = 0

  Blue2(12) = 10
  Green2(12) = 10
  Red2(12) = 40

  Blue2(13) = 40
  Green2(13) = 0
  Red2(13) = 40

  Blue2(14) = 0
  Green2(14) = 40
  Red2(14) = 40

  Blue2(15) = 40
  Green2(15) = 40
  Red2(15) = 40
 
  Fading = 0
  DO
    DO
      Kolor = INT(RND * 15) + 1
    LOOP UNTIL Done(Kolor) = 0
    Done(Kolor) = 1
    Faded = Faded + 1
    Fading = Kolor
    IF Faded = 15 THEN
      FOR Kolor = 1 TO 15
        Done(Kolor) = 0
      NEXT Kolor
      Faded = 0
    END IF

    IF Red(Fading) < Red2(Fading) THEN Red(Fading) = Red(Fading) + 5
    IF Blue(Fading) < Blue2(Fading) THEN Blue(Fading) = Blue(Fading) + 5
    IF Green(Fading) < Green2(Fading) THEN Green(Fading) = Green(Fading) + 5
  
    Fade = 65536 * INT(Blue(Fading)) + 256 * INT(Green(Fading)) + INT(Red(Fading))
  
    PALETTE Fading, Fade
  LOOP UNTIL Red(15) = Red2(15)
  PALETTE
END SUB

' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
' |                THE QUICKBASIC SUB COLLECTION: FadeInSetup               |
' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
SUB FadeInSetup
  FOR x = 0 TO 15
    PALETTE x, 0
  NEXT x
END SUB

' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
' |                  THE QUICKBASIC SUB COLLECTION: FadeOut                 |
' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
SUB FadeOut
  DIM Blue(15)
  DIM Green(15)
  DIM Red(15)
  DIM Done(15)

  Blue(1) = 40
  Green(1) = 0
  Red(1) = 0
 
  Blue(2) = 0
  Green(2) = 40
  Red(2) = 0
 
  Blue(3) = 40
  Green(3) = 40
  Red(3) = 0
 
  Blue(4) = 0
  Green(4) = 0
  Red(4) = 40
   
  Blue(5) = 40
  Green(5) = 0
  Red(5) = 40
 
  Blue(6) = 0
  Green(6) = 20
  Red(6) = 40
 
  Blue(7) = 40
  Green(7) = 40
  Red(7) = 40
 
  Blue(8) = 20
  Green(8) = 20
  Red(8) = 20
 
  Blue(9) = 40
  Green(9) = 20
  Red(9) = 10
 
  Blue(10) = 0
  Green(10) = 40
  Red(10) = 0
 
  Blue(11) = 40
  Green(11) = 40
  Red(11) = 0
 
  Blue(12) = 15
  Green(12) = 15
  Red(12) = 40
 
  Blue(13) = 40
  Green(13) = 0
  Red(13) = 40
 
  Blue(14) = 0
  Green(14) = 40
  Red(14) = 40
 
  Blue(15) = 40
  Green(15) = 40
  Red(15) = 40
  
  Fading = 0
  DO
    DO
      Kolor = INT(RND * 15) + 1
    LOOP UNTIL Done(Kolor) = 0
    Done(Kolor) = 1
    Faded = Faded + 1
    Fading = Kolor
    IF Faded = 15 THEN
      FOR Kolor = 1 TO 15
        Done(Kolor) = 0
      NEXT Kolor
      Faded = 0
    END IF

    IF Red(Fading) > 0 THEN Red(Fading) = Red(Fading) - 5
    IF Blue(Fading) > 0 THEN Blue(Fading) = Blue(Fading) - 5
    IF Green(Fading) > 0 THEN Green(Fading) = Green(Fading) - 5
   
    Fade = 65536 * INT(Blue(Fading)) + 256 * INT(Green(Fading)) + INT(Red(Fading))
   
    PALETTE Fading, Fade
  LOOP UNTIL Red(15) = 0
  CLS
  PALETTE
END SUB

' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
' |               THE QUICKBASIC SUB COLLECTION: FadeOutColor               |
' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'
SUB FadeOutColor (ColorFading)
    IF ColorFading = 1 THEN
      Blue = 40
      Green = 0
      Red = 0
    ELSEIF ColorFading = 2 THEN
      Blue = 0
      Green = 40
      Red = 0
    ELSEIF ColorFading = 3 THEN
      Blue = 40
      Green = 40
      Red = 0
    ELSEIF ColorFading = 4 THEN
      Blue = 0
      Green = 0
      Red = 40
    ELSEIF ColorFading = 5 THEN
      Blue = 40
      Green = 0
      Red = 40
    ELSEIF ColorFading = 6 THEN
      Blue = 0
      Green = 20
      Red = 40
    ELSEIF ColorFading = 7 THEN
      Blue = 40
      Green = 40
      Red = 40
    ELSEIF ColorFading = 8 THEN
      Blue = 20
      Green = 20
      Red = 20
    ELSEIF ColorFading = 9 THEN
      Blue = 50
      Green = 20
      Red = 10
    ELSEIF ColorFading = 10 THEN
      Blue = 0
      Green = 60
      Red = 0
    ELSEIF ColorFading = 11 THEN
      Blue = 50
      Green = 50
      Red = 0
    ELSEIF ColorFading = 12 THEN
      Blue = 16
      Green = 16
      Red = 62
    ELSEIF ColorFading = 13 THEN
      Blue = 40
      Green = 0
      Red = 40
    ELSEIF ColorFading = 14 THEN
      Blue = 0
      Green = 60
      Red = 60
    ELSEIF ColorFading = 15 THEN
      Blue = 50
      Green = 50
      Red = 50
    END IF
    DO
      IF Red > 0 THEN Red = Red - 1
      IF Blue > 0 THEN Blue = Blue - 1
      IF Green > 0 THEN Green = Green - 1

      ' Select VGA color code to fade into
      Fade = 65536 * Blue + 256 * Green + Red

      ' Switch color on screen automatically using "PALETTE"
      PALETTE ColorFading, Fade
  LOOP UNTIL Green = 0 AND Red = 0 AND Blue = 0

  ' Clear screen and return original color settings
  CLS
  PALETTE
END SUB

' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
' |               THE QUICKBASIC SUB COLLECTION: FadeOutColors              |
' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'
SUB FadeOutColors
  FOR ColorFading = 1 TO 15
    ' Original color settings for each of the 15 colors
    IF ColorFading = 1 THEN
      Blue = 40
      Green = 0
      Red = 0
    ELSEIF ColorFading = 2 THEN
      Blue = 0
      Green = 40
      Red = 0
    ELSEIF ColorFading = 3 THEN
      Blue = 40
      Green = 40
      Red = 0
    ELSEIF ColorFading = 4 THEN
      Blue = 0
      Green = 0
      Red = 40
    ELSEIF ColorFading = 5 THEN
      Blue = 40
      Green = 0
      Red = 40
    ELSEIF ColorFading = 6 THEN
      Blue = 0
      Green = 20
      Red = 40
    ELSEIF ColorFading = 7 THEN
      Blue = 40
      Green = 40
      Red = 40
    ELSEIF ColorFading = 8 THEN
      Blue = 20
      Green = 20
      Red = 20
    ELSEIF ColorFading = 9 THEN
      Blue = 50
      Green = 20
      Red = 10
    ELSEIF ColorFading = 10 THEN
      Blue = 0
      Green = 60
      Red = 0
    ELSEIF ColorFading = 11 THEN
      Blue = 50
      Green = 50
      Red = 0
    ELSEIF ColorFading = 12 THEN
      Blue = 16
      Green = 16
      Red = 62
    ELSEIF ColorFading = 13 THEN
      Blue = 40
      Green = 0
      Red = 40
    ELSEIF ColorFading = 14 THEN
      Blue = 0
      Green = 60
      Red = 60
    ELSEIF ColorFading = 15 THEN
      Blue = 50
      Green = 50
      Red = 50
    END IF
    DO
      IF Red > 0 THEN Red = Red - .5
      IF Blue > 0 THEN Blue = Blue - .5
      IF Green > 0 THEN Green = Green - .5

      ' Select VGA color code to fade into
      Fade = 65536 * INT(Blue) + 256 * INT(Green) + INT(Red)

      ' Switch color on screen automatically using "PALETTE"
      PALETTE ColorFading, Fade
    LOOP UNTIL Green = 0 AND Red = 0 AND Blue = 0
  NEXT ColorFading
 
  ' Clear screen and return original color settings
  CLS
  PALETTE
END SUB

SUB Hold
  WHILE INKEY$ = "": WEND
END SUB

SUB RandomDots (Number, Kolor)
  FOR Times = 1 TO Number
    DotOne = INT(RND * 700) + 1
    DotTwo = INT(RND * 500) + 1
    DotColor = INT(RND * 15) + 1
    IF Kolor = 1 THEN PSET (DotOne, DotTwo), DotColor ELSE PSET (DotOne, DotTwo), 15
  NEXT Times
END SUB

' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
' |                   THE QUICKBASIC SUB COLLECTION: Rest                   |
' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
SUB Rest (Seconds!)
  Start! = TIMER
  DO WHILE TIMER < Start! + Seconds!
  LOOP
END SUB

' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
' |                THE QUICKBASIC SUB COLLECTION: TypeWrite                 |
' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
SUB TypeWrite (Row, Col, Text$, Kolor)
  COLOR Kolor
  LOCATE Row, Col
  FOR x = 1 TO LEN(Text$)
    Letter$ = RIGHT$(LEFT$(Text$, x), 1)
    IF Letter$ = "~" THEN
      Start! = TIMER
      DO WHILE TIMER < Start! + .5
      LOOP
    ELSE
      PRINT Letter$;
      SOUND 750, .1
      Start! = TIMER
      DO WHILE TIMER < Start! + .005
      LOOP
    END IF
  NEXT x
END SUB

